package associations;

import java.util.HashMap;
import java.util.Map;

/**
 * Other way to remove mutual dependency
 * Lookup in one direction 
 * @author hajo
 *
 */
public class RemoveMutualAssociations3 {

	public static void main(String[] args) {
		// Lookup in one direction (given a Customer is worse)
		Map<Order, Customer> orderCustomer = new HashMap<>();
		
		Order o = new Order(123L);
		Customer c = new Customer();
		orderCustomer.put(o, c);
		
		Customer whoToBill = orderCustomer.get(o);
		System.out.println(whoToBill);

	}

	public static class Order {
		long id;
		// No dependency on Customer
		
		public Order( long id){
			this.id = id;
		}

		// These are important!
		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + (int) (id ^ (id >>> 32));
			return result;
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			Order other = (Order) obj;
			if (id != other.id)
				return false;
			return true;
		}
		
	}

	public static class Customer {
		// No dependency on Order
	}

}
