package canonical.equal;

/**
 * Using equals by value (Object.equal is by reference)
 * 
 * NOTE : this doesn't work with inheritance, see inheritance
 * 
 * @author hajo
 * 
 */
public class BasicEquals {

	public static void main(String[] args) {
		MyClass a = new MyClass(1);
		MyClass b = new MyClass(1);
		
		System.out.println(a.equals(b));
		// If equal should have same hashCode
		System.out.println(a.hashCode() + " " + b.hashCode());
	}

	public static class MyClass {

		private long id;

		public MyClass(long id) {
			this.id = id;
		}

       
        // Warning: Doesn't work with inheritance
        @Override
        public boolean equals(Object obj) {
            if (this == obj)
                return true;
            if (obj == null)
                return false;
            if (getClass() != obj.getClass())
                return false;
            MyClass other = (MyClass) obj;
            if (id != other.id)
                return false;
            return true;
        }
        
        @Override
        public int hashCode() {
            final int prime = 31;
            int result = 1;
            result = prime * result + (int) (id ^ (id >>> 32));
            return result;
        }

	}

}
