package canonical.equal;

import java.util.HashMap;
import java.util.Map;

/**
 * Must override hashCode if overriding equals 
 * 
 * @author hajo
 * 
 */
public class EqualsNoHashCode {

	public static void main(String[] args) {
		MyClass a = new MyClass(1);
		MyClass b = new MyClass(1);

		System.out.println(a.equals(b));
		// If equal should have same hashCode
		System.out.println(a.hashCode() + " " + b.hashCode());

		
		Map<MyClass, String> m = new HashMap<MyClass, String>();
		// Use a as key
		m.put(a, "AAA");
		// b equals a but not found!
		System.out.println(m.get(b));
	}

	public static class MyClass {

		private long id;

		public MyClass(long id) {
			this.id = id;
		}

		 // Warning: Doesn't work with inheritance
        @Override
        public boolean equals(Object obj) {
            if (this == obj)
                return true;
            if (obj == null)
                return false;
            if (getClass() != obj.getClass())
                return false;
            MyClass other = (MyClass) obj;
            if (id != other.id)
                return false;
            return true;
        }
        /*
        @Override
        public int hashCode() {
            final int prime = 31;
            int result = 1;
            result = prime * result + (int) (id ^ (id >>> 32));
            return result;
        }*/
	}

}
