package dp.state;

/**
 * Class responsible for handling the states
 * @author hajo
 *
 */
public final class StateContext implements IStateContext {

    private final IState aState = new AState();
    private final IState bState = new BState();
    private IState current = aState;

    public void doIt() {
        current.doIt();
    }

    public void doOther() {
        current.doOther();
    }

    // Possible exception handling...
    @Override
    public void switchToA() {
        current = aState;
    }

    @Override
    public void switchToB() {
        current = bState;
    }
}
