package exception.nonlocaltransfer;

/**
 * Exception handling introduces non-local jumps.
 * Simple to follow here but could be hard.
 * 
 * Normal call chain: doA -> doB -> doC -> doD -> doC -> doB -> doA
 * 
 * @author hajo
 *
 */
public class NonLocalTransfer {

	public static void main(String[] args) {
		try {
			new A().doA();
		}catch( RuntimeException e){
			// End up here... 
			System.out.println(e.getMessage());
		}
	}

	public static class A {
		// Jump through this 
		public void doA(){
			new B().doB();
		}
	}

	public static class B {
		// Jump through this 	
		public void doB(){
			new C().doC();
		}
	}

	public static class C {
		// Jump through this 
		public void doC(){
			new D().doD();
		}
	}

	public static class D {
		// Exception thrown
		public void doD(){
			throw new RuntimeException("Exception");
		}
	}
}
