package mvc.controlview1;

import java.awt.Container;
import java.awt.GridLayout;

import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.WindowConstants;

/**
 * The view part of application
 * @author hajo
 *
 */

@SuppressWarnings("serial")
public class MainFrame extends JFrame  {
	
	private final Action control;

    public MainFrame(Action control) {
    	this.control = control;
        init();
        initControl();
    }


    private void initControl() {
    	 // Store reference to GUI component
        control.putValue(Control.OUT, out);
        control.putValue(Control.IN, in);
        /*
         * Adding control as listener
         */
        btn.addActionListener(control);	
        
    }
  
    // --------- Boring GUI code below --------------
    JButton btn = new JButton("SetI");
    JTextField in = new JTextField("");
    JLabel out = new JLabel();

    private void init() {
        this.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        this.setLayout(new GridLayout(3, 1));
        Container c = this.getContentPane();
        c.add(in);
        c.add(btn);
        c.add(out);
        this.setSize(200, 200);
    }

}
