package canonical.equal;

/**
 * Must override hashCode if overriding equals
 *
 * @author hajo
 *
 */
public class MyBadClass {

    private final long id;

    public MyBadClass(long id) {
        this.id = id;
    }

    // Warning: Doesn't work with inheritance
    @Override
    public boolean equals(Object obj) { // Warning for missing hashCode
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        MyBadClass other = (MyBadClass) obj;
        return id == other.id;
    }
    // Works if uncommented
    /*@Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (id ^ (id >>> 32));
        return result;
    }*/
}


