package exception.bestpractices;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

/**
 * Handling all errors in a very messy way
 * @author Java Best Practices
 *
 */
public class BadFileHandler {

    // BAD; BAD; BAD; ....
    public void simpleFinally(String aFileName) {

        BufferedReader reader = null;
        try {
            reader = new BufferedReader(new FileReader(aFileName));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        // If exception continue here (Note: reader possible null)

        String line = null;
        try {
            if (reader != null) {
                while ((line = reader.readLine()) != null) {
                    //process the line...
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

        try {
            if (reader != null) {
                reader.close();
            }
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

}
