package exception.bestpractices;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

/**
 * Using try-with-resources (the Readers are auto closable)
 * @author Java Best Practices
 */
public class FileHandler3 {

    public static void nestedFinally(String aFileName) {
        try {
            try (BufferedReader reader = new BufferedReader(
                    new FileReader(aFileName))) {
                String line = null;
                while ((line = reader.readLine()) != null) {
                    //process the line...
                }
            }
        } catch (IOException ex) {
            //fLogger.severe("Problem occured : " + ex.getMessage());
        }
    }
}
