package option;

/**
 * Testing using Options instead of returning null
 *
 * @author hajo
 */
public class TestOptions {

    public static void main(String[] args) {
        MyClass m = new MyClass();

        Option<Object> o = m.getIt();
        Object value = o.getOrElse("Alternative");

        System.out.println(value);
    }

    // ------ TYPES ------------------
    // Class using Option
    public static class MyClass {

        public Object possibleNull;

        public Option<Object> getIt() {
            if (possibleNull == null) {
                return new None<Object>();
            } else {
                return new Some<Object>(possibleNull);
            }
        }

        public void setIt(Object o) {
            possibleNull = o;
        }

    }

}
