package dp.visitor.wildcards;

/**
 * Just the structure no calculations here
 * @author hajo
 *
 * @param <T>  data in Node
 */
public class Node<T> implements ITree<T> {

    private final T t;
    private final ITree<T> left;
    private final ITree<T> right;

    public Node(T t, ITree<T> left, ITree<T> right) {
        super();
        this.t = t;
        this.left = left;
        this.right = right;
    }

    @Override
    public <R> R accept(IVisitor<R, ? super T> v) {
        return v.visit(this);
    }

    public T getIt() {
        System.out.print("Node");
        return t;
    }

    public ITree<T> getLeft() {
        return left;
    }

    public ITree<T> getRight() {
        return right;
    }

}
