package generic.erasure;


/**
 * This tries to show the effect of of type erasure 
 * see all files
 */


final class NumericValue implements Comparable<NumericValue> {
    private final byte value;
    public NumericValue(byte value) {
        this.value = value;
    }
    public byte getValue() {
        return value;
    }
    @Override
    public int compareTo(NumericValue that) {
        return this.value - that.value;
    }
}

/* After
final class NumericValue implements Comparable {
    private byte value; 
    public  NumericValue (byte value) { this.value = value; } 
    public  byte getValue() { return value; } 
    public  int compareTo( NumericValue that){ return this.value - that.value; }
    // Bridge method!! Erased interface has this signature
    public  int compareTo(Object that) { return this.compareTo((NumericValue)that);  }
  } 
*/