package generic.typesafecovariance;

import java.util.ArrayList;
import java.util.List;

/**
 * Generic types are not covariant i.e
 * S :> T does **not** imply C<S> :> C<T>
 * @author hajo
 *
 */
public class TypeSafeCovariance {

    /**
     * @param args
     */
    public static void main(String[] args) {
        // Array loop hole, Object[] :> String[]
        String[] strings = new String[1];
        Object[] objects = strings; 
        //objects[0] = new Integer(1);// Oh, oh      
        //String s = strings[0].substring(0);// The array loophole!!

        List<String> slist = new ArrayList<>();
        slist.add("a");
        //List<Object> olist = slist;   // No!
        
        // Ok, ...
        List<? extends Object> olist2 = slist;
        // ... but can just treat elements as Objects
        // s = olist2.get(0);
        Object o = olist2.get(0); // Safe
    }
}
