package generic.wildcard.restrictions;

import java.util.ArrayList;
import java.util.List;

/**
 * Restrictions on <? super T > collection
 * @author hajo
 *
 */
public class RestrictionsLowerBound2 {

    public static void main(String[] args) {
        List<? super C> list;

        // List could be any of these
        list = new ArrayList<C>();// Integer is a "superclass" of Integer (in this context)
        list = new ArrayList<B>(); // Number is a superclass of Integer
        list = new ArrayList<A>();

        // Read
        /*
        The only guarantee is that you will get an instance of an Object.
        */
        Object o = list.get(0);

        // Write
        // C and D will be possible for all the above ArrrayLists
        list.add(new C());
        list.add(new D());
        list.add(null);

    }

    public static class A {

    }

    public static class B extends A {

    }

    public static class C extends B {

    }

    public static class D extends C {

    }

}
