package reflection.access;

import java.lang.reflect.Field;

/**
 * Can use reflection to access private attributes
 *
 * @author hajo
 *
 */
public class ViolateAccess {

    public static void main(String[] args) {
        A a = new A();
        Class<?> clazz = a.getClass();

        System.out.println(a.getI());
        try {
            Field f = clazz.getDeclaredField("i");
            // Oh, oh, ...
            f.setAccessible(true);
            f.set(a, 2);
            f.setAccessible(false);
        } catch (NoSuchFieldException | SecurityException | IllegalArgumentException |
                IllegalAccessException e) {
            e.printStackTrace();
        }
        System.out.println(a.getI());
    }

    public static class A {

        // Harder if this is final, but possible??? Think so.. U check
        private int i = 1;

        public int getI() {
            return i;
        }
    }

}
