package reflection.instantiation;

/**
 * A class using reflection to create instances Not possible to create generic
 * types
 *
 * Usage see Main
 *
 * @author hajo
 *
 * @param <T>
 */
public final class ReflexiveCreator<T> {

    private final Class<T> clazz;

    // Must use Class as a prototype
    public ReflexiveCreator(Class<T> clazz) {
        this.clazz = clazz;
    }

    public T getIt() {
        T t = null;
        try {
            t = clazz.newInstance();
        } catch (InstantiationException | IllegalAccessException e) {
            e.printStackTrace();  // Bad fix
        }
        return t;
    }
}
