package declarative;

/**
 * Power function in declarative vs imperative style
 * 
 * NOTE: Declarative style is easier to reason about.
 *  
 * @author hajo
 *
 */
public class DeclarativeVsImperative {

	public static void main(String[] args) {
		System.out.println(power(2, 8));
		System.out.println(powerRec(2, 8));
		
		System.out.println(powerRecTail(2, 8, 1));
	}

	// Imperative style
	public static int power(int a, int b) {
		int result = 1;
		int i = 0;
		while (i < b) {
			result *= a;
			i++;
		}
		return result;
	}

	// -------  Declarative  style --------------
	
	public static int powerRec(int a, int b) {
		if (b == 0) {
			return 1;
		} else {
			// NOT tail recursive (multiply after call returned)
			return a * powerRec(a, b - 1); 
		}
	}
	
	public static int powerRecTail(int a, int b, int result) {
		if (b == 0) {
			return result;
		} else {
			return powerRecTail(a, b - 1, result * a); // Tail recursive
		}
	}
	

}
