package imperativeproof;

/**
 *
 * Proving loops using loop invariants
 *
 * @author hajo
 *
 */
public class TestLoopInvariant {

    public static void main(String[] args) {
        System.out.println(power(2, 8));

    }

    // Invariant i <= b && result = a ^ i
    public static int power(int a, int b) {
        int result = 1;
        int i = 0;
        // Inv must be true here
        System.out.println("Invariant = " + checkInvariant(a, b, i, result));
        System.out.println("Guard = " + (i < b));
        while (i < b) {
            // If true here...
            result *= a;   // NOTE: Invariant doesn't hold here
            System.out.println("Invariant = " + checkInvariant(a, b, i, result));
            i++;  // Restored here
            System.out.println("Invariant = " + checkInvariant(a, b, i, result));
            System.out.println("Guard = " + (i < b));
            // ..must be true here
        }
        // .. What can we deduce form inv. here?
        return result;
    }

    private static boolean checkInvariant(int a, int b, int i, int result) {
        return i <= b && result == Math.pow(a, i);
    }
}
