package tree;

import java.util.ArrayList;
import java.util.List;

/**
 * A tree data structure
 *
 * @author hajo
 */
public class Tree {

    private final Node root; // Just one start reference to all nodes

    public Tree(Node root) {
        this.root = root;

    }

    // Need a "start" method to get recursion going
    int countNodes() {

        //return countNodesR(root);
        List<Node> nodes = new ArrayList<>();
        countNodesRT(root, nodes);
        return nodes.size();

    }

    // Recursive traversing and counting. Not tail recursive
    private int countNodesR(Node node) {
        if (node == null) {
            return 0;
        } else {
            return 1 + countNodesR(node.left) + countNodesR(node.right);
        }

    }

    // Recursive traversing and counting. Tail recursive.
    // NOTE: Parameter nodes is identical through all recursive calls
    // This is high lighted with final
    private void countNodesRT(Node node, final List<Node> nodes) {
        if (node == null) {
            return;
        } else {
            if (nodes.indexOf(node) < 0) {
                nodes.add(node);
            }
            countNodesRT(node.left, nodes);
            countNodesRT(node.right, nodes);
        }
    }
}
