package equals.delegation;

import java.util.Date;

/**
 * An extension to the java.util.Data class without inheritance
 * See Angelica Langer FAQ
 * 
 * @author Angelica Langer
 *
 */
public class NamedDate { // does not extend Date
    private String name;
    private Date date; // Date as a field instead of a superclass

    // ...
    public boolean equals(Object other) {
        if (other != null && getClass() == other.getClass()) {
            if (date.equals(((NamedDate) other).date)
                    && name.equals(((NamedDate) other).name))
                return true;
        }
        return false;
    }

    // ...
    public boolean before(Date when) {
        return date.before(when);
    }

    public boolean after(Date when) {
        return date.after(when);
    }
    /* Possible if mixed type comparison needed
    NamedDate.isSameDateAs(Date) 
    Date.isSameDateAs(NamedDate)
    */
}
