package equals.sametype.nofields;

import java.util.HashMap;
import java.util.Map;

/**
 * Same only equals NO significant field in subclass
 * 
 */
public class Main {

    public static void main(String[] args) {
        // Equals by pnumber
        Person p = new Person("11223344-5566");
        // Both inherit equals
        Student s = new Student("11223344-5566");
        Employee e = new Employee("11223344-5566");

        // Yes, reflexive
        System.out.println(e.equals(e));
        System.out.println(s.equals(s));
        System.out.println(p.equals(p));

        // Symmetry, No, none true, same only equal
        System.out.println(s.equals(e));
        System.out.println(e.equals(s));
        System.out.println(s.equals(p));
        System.out.println(p.equals(s));
        System.out.println(e.equals(p));
        System.out.println(p.equals(e));

        Map<Person, String> map = new HashMap<Person, String>();
        map.put(s, "s");
        // Can't find as other type (have same hashCode)
        System.out.println(map.get(p));
        System.out.println(map.get(e));
    }
}
