package inherit.init.ctor;

/**
 * Never overridden method in constructor
 */
public class NeverOverrideInConstructor {

    public static void main(String[] args) {
        B b = new B();
        System.out.println(b);
    }

    public static class A {

        protected String data = null;

        public A() {
            System.out.println("A start ctor");
            // Calling own method
            doImportantStuff();
        }

        // Should be final
        public void doImportantStuff() {
            data = "Inited...";
        }
    }

    public static class B extends A {

        // Constructor for A called first
        public B() {
            System.out.println("B start ctor");
        }

        @Override
        public void doImportantStuff() {
            data.length(); // Null pointer...
        }
    }

}
