package liskov;

/**
 * Violating Liskov Substitution Principle, can't use subclass for super.
 * 
 * 
 * NOTE:  P(a) && P(b) is a stronger predicate than either of P(a), P(b)
 * 		  P(a) || P(b) is a weaker predicate than either	
 * 
 */
public class Main {

	public static void main(String[] args) {
		// Ok, assuming a rectangle or something
		// that fulfills the contract of rectangle
		Rectangle r = Factory.getSomething();
		// Should be ok...
		r.setWidth(5);
		r.setHeight(4);
		// ...but not! Violating contract not proper a sub type!!!
		System.out.println("Area " + r.area());
	}
}
/*
 * 
 * NOTE: In real world Square is a specialization of Rectangle
 * but not in programming....!!
 * 
 */
