package clone.inheritance;

import java.util.Date;

/**
 * Top level class should handle exceptions, no exception handling in sub
 * classes
 *
 * Reference http://www.angelikalanger.com/Articles/EffectiveJava/07.
 * Clone-Part3/07.Clone-Part3.html
 */
public class A implements Cloneable {

    private int i = 111;

    private Date date = new Date();

    @Override
    public Object clone() {
        try {
            A a = (A) super.clone();
            a.date = new Date(date.getTime());
            return a;
        } catch (CloneNotSupportedException e) {
            // .. something is very wrong
            throw new InternalError();
        }
    }

    public int getI() {
        return i;
    }

    public void setI(int i) {
        this.i = i;
    }

    public Date getDate() {
        return date;
    }
}
