package dp.decorator;

/**
 * Decorator pattern, an alternative to inheritance
 * 
 * Instead of fixed inherited behavior we can dynamically
 * compose extended behavior
 * 
 * @author Wikipedia (modified by hajo)
 *
 */
public class TestDecorator {

    public static void main(String[] args) {
        // Create a decorated Window with horizontal and vertical scrollbars
        IWindow decoratedWindow = new HorizontalScrollBarDecorator(
                new VerticalScrollBarDecorator(new SimpleWindow()));

        // Print the Window's description
        System.out.println(decoratedWindow.getDescription());
        
        // Also possible
        //IWindow decoratedWindow2 = new VerticalScrollBarDecorator(
        //        new HorizontalScrollBarDecorator(new SimpleWindow()));
    }

}
