package dp.decorator;

/**
 * The first concrete decorator which adds vertical scrollbar functionality
 *
 * @author hajo
 */
public class VerticalScrollBarDecorator extends AbstractWindowDecorator {

    public VerticalScrollBarDecorator(IWindow decoratedWindow) {
        super(decoratedWindow);
    }

    @Override
    public void draw() {
        decoratedWindow.draw();
        drawVerticalScrollBar();
    }

    private void drawVerticalScrollBar() {
        // draw the vertical scrollbar
    }

    @Override
    public String getDescription() {
        return decoratedWindow.getDescription()
                + ", including vertical scrollbars";
    }
}
