package equals.mixedtype;

import java.util.HashMap;
import java.util.Map;

/**
 * Mixed type "equals"
 */
public class TestEqualsMixedType {

    public static void main(String[] args) {
        A a = new A(1);   // afield = 1 
        B b = new B(1, 2);// afield = 1, equal by value on afield 

        // Reflexivity, yes, 
        System.out.println("Reflexivity a-a " + a.equals(a));// True
        System.out.println("Reflexivity b-b " + b.equals(b));// True

        // Symmetry, no just one way
        System.out.println("Symmetry a-b " + a.equals(b)); // True (uses afield only)
        System.out.println("Symmetry b-a " + b.equals(a)); // False 

    // Transitivity, no
        // Lookup ok for A objects
        System.out.println("*** Lookup ***");
        Map<A, String> map = new HashMap<A, String>();
        map.put(b, "b");
        // Use base class as key
        System.out.println(map.get(a)); // If same hashCode this works! 
        System.out.println(map.get(b));

        A a1 = new B(2, 3);
        B b1 = new B(2, 3);
        System.out.println("Runtime class " + a1.equals(b1));  // Runtime ok, true

    }
}
