package equals.workaround;

/**
 * Baseclass
 * 
 * @author hajo
 * 
 */
public class Person {

    protected final String pNumb; // Only significant field for equals

   
    public Person(String pNumb) {
        this.pNumb = pNumb;
    }

    // NOTE: Can't override these
    @Override
    public final int hashCode() {
        final int PRIME = 31;
        int result = 1;
        result = PRIME * result + ((pNumb == null) ? 0 : pNumb.hashCode());
        return result;
    }

    @Override
    public final boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (!(obj instanceof Person)) { // Mixed type!!
            return false;
        }
        Person other = (Person) obj;
        return pNumb.equals(other.pNumb);// Use String.equal
    }

}
