package equals.workaround;

import java.util.HashMap;
import java.util.Map;

/**
 * Mixed-type "equals" NO significant field in subclass
 * 
 * 
 * 
 * .. NOTE: U shouldn't use inheritance for roles (because
 * 	  roles changes (use attribute role)
 */

public class TestWorkaround {

  public static void main(String[] args) {

    Student s = new Student("11223344-5566");
    Employee e = new Employee("11223344-5566");
    Person p = new Person("11223344-5566");

    // Reflexivity, yes
    System.out.println("Reflexivity");
    System.out.println(e.equals(e));
    System.out.println(s.equals(s));
    System.out.println(p.equals(p));

    // Symmetry, yes
    System.out.println("Symmetry");
    System.out.println(s.equals(e)); 
    System.out.println(e.equals(s));
    System.out.println(p.equals(s)); 
    System.out.println(s.equals(p)); 
    System.out.println(p.equals(e));
    System.out.println(e.equals(p));

    // Transitivity, yes
    System.out.println("Transitivity");
    System.out.println(p.equals(e));
    System.out.println(e.equals(s));
    System.out.println(p.equals(s));

    // Lookup, yes
    System.out.println("*** Lookup ***");
    Map<Person, String> map = new HashMap<Person, String>();
    map.put(s, "s");
    System.out.println(map.get(s));
    System.out.println(map.get(p));
    System.out.println(map.get(e));
  }
}
