package fragilebaseclass;

import java.util.Collection;

/**
 * Extending Set with a counter
 * @author hajo
 *
 */
public class CountingSet extends Set {

    private int counter;

    @Override
    public void add(Integer i){
        super.add(i);
        counter++;
    }
    
    @Override
    public void addAll( Collection<Integer> c ){
       super.addAll(c); 
       counter += c.size();    
    }
  
    public Integer getCount() {
        return new Integer(counter);
    }
}
