package inherit._super;

/**
 *
 * @author hajo
 */
public class B extends A {

    private final A a1 = this;
    
    //private final A a2 = super;  //No!
    //private final B b = super;  //No!
    private final String s = super.toString();

    // Hiding 
    protected static void doIt() {
        System.out.println("B.doIt()");
    }

    @Override
    protected final void doOther() {
        System.out.println("B.doOther()");
    }

    // super is different from this (it's not a Primary)
    public B() {
        // Type for referenced runtime object is ....
        System.out.println("this class is " + this.getClass().getSimpleName());
        System.out.println("super class is " + super.getClass().getSimpleName());
        System.out.println(this.toString());
        System.out.println(super.toString());

        // System.out.println(a1== super);  // No!
        // System.out.println(super == this);  // No!
        //Object o = super;                   // No! 
        // super = o                          // No!
        this.doIt(); // Bad style!
        this.doOther();

        super.doIt();
        super.doOther();

        ((A) this).doIt();  // definition of super
        ((A) this).doOther();
    }

}
