package edu.gu.cid.dict;

import java.util.Arrays;

/**
 * Utility to convert from/to strings 
 * 
 * @author hajo
 * 
 */
class DictionaryEntryConverter {
	
	public final static String KEY_VALUES_SEPARATOR = "=";
	public final static String WORD_SEPARATOR = ",";

	public DictionaryEntry toObject(String s) {
		String[] splitLine = s.split(KEY_VALUES_SEPARATOR);
		String word = splitLine[0].trim();
		String[] trans = splitLine[1].trim().split(WORD_SEPARATOR);
		return new DictionaryEntry(word, Arrays.asList(trans));
	}

	// The inverse, not used
	public String toString(DictionaryEntry e) {
		StringBuilder b = new StringBuilder();
		b.append(e.getSource() + KEY_VALUES_SEPARATOR);
		for (String t : e.getTranslations()) {
			b.append(t + WORD_SEPARATOR);
		}
		b.delete(b.length() - 1, b.length()); // Remove last tSepChar
		return b.toString();
	}

}
