package edu.gu.cid.translator;

import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;

import edu.gu.cid.translator.core.Translator;
import edu.gu.cid.translator.gui.GUIFactory;
import edu.gu.cid.translator.gui.MainFrame;



/**
 * Application entry point
 * 
 * @author hajo
 * 
 */
public class Main {

	public static void main(String[] args) {

		try {
			/*
			 * Don't need to understand the below for now Use invokeAndWait to
			 * block i.e. let GUI show up before updating
			 */
			SwingUtilities.invokeAndWait(new Runnable() {
				public void run() {
					MainFrame mf = GUIFactory.getGUI(new Translator());
					mf.setLocationRelativeTo(null);
					mf.setVisible(true);
				}
			});
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(null,
					"Sorry, can't start application. " + e.getMessage());
			System.exit(1);
		}
	}
}
