package edu.gu.cid.translator.event;

/**
 * A single event
 * 
 * @author hajo
 * 
 */
public class Event {
	// All possible events listed
	public enum Tag {
		FROM_LANG_CHANGED, TO_LANG_CHANGED, INPUT_CHANGED
	}

	private final Tag tag;
	// The new value
	private final Object value;

	public Event(Tag tag, Object value) {
		this.tag = tag;
		this.value = value;
	}
	
	public Tag getTag() {
		return tag;
	}

	public Object getValue() {
		return value;
	}

	@Override
	public String toString() {
		return "Event [tag=" + tag + ", value=" + value + "]";
	}
}
