package edu.gu.cid.translator.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.util.List;

import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.ListModel;

import edu.gu.cid.dict.DictionaryEntry;
import edu.gu.cid.translator.core.Constants;
import edu.gu.cid.translator.event.Event;
import edu.gu.cid.translator.event.IEventHandler;
import edu.gu.cid.translator.util.IWritablePanel;


/**
 * Panel for the input text field (word to translate) and the output (list of
 * translations)
 * 
 * @author hajo
 * 
 *         TODO Localize (border)
 */
@SuppressWarnings("serial")
public class DisplayPanel extends JPanel implements IEventHandler, IWritablePanel<List<DictionaryEntry>>  {

	private final JTextField inPut = new JTextField();
	private final JList<String> outPut = new JList<>();

	private final static int DEFAULT_SIZE = 60;
	private final static ListModel<String> DEFAULT_MODEL = new DefaultComboBoxModel<>(
			new String[DEFAULT_SIZE]);

	public DisplayPanel() {
		init();
	}

	// This works
	public void write(List<DictionaryEntry> matches) {
		DefaultListModel<String> model = new DefaultListModel<>();
		for (DictionaryEntry e : matches) {
			StringBuffer b = new StringBuffer();
			for (String s : e.getTranslations()) {
				b.append(s).append(",");
			}
			model.addElement(e.getSource() + ": " + b.toString());
		}
		outPut.setModel(model);
	}

	@Override
	public void onEvent(Event evt) { 
		
	}

	private void clear() {
		outPut.setModel(DEFAULT_MODEL);
		inPut.setText(Constants.EMPTY_STR);

	}

	private void init() {
		this.setLayout(new BorderLayout());
		this.setPreferredSize(new Dimension(200, 200));
		inPut.setEditable(false);
		this.add(inPut, BorderLayout.NORTH);
		this.add(outPut, BorderLayout.CENTER);

	}
}
