package edu.gu.cid.translator.util;

import edu.gu.cid.translator.core.Language;

/**
 * Helper class. Used to populate ComboBoxes (key shown in GUI 
 * because of overridden toString, but value used internal by application). 
 * 
 * @author hajo
 * 
 */
public final class SelectItem {

	private final String key;
	private final Language value;

	public SelectItem(String key, Language Language) {
		this.key = key;
		this.value = Language;
	}

	// This is shown in GUI "the key"
	@Override
	public String toString() {
		return key;
	}

	// This is the selected item used internally by application
	public Language getValue() {
		return value;
	}
}
