package edu.gu.hajo.mbcommon;

import java.io.Serializable;

/**
 * Shared core class MUST be serializable
 * Immutable
 *
 * @author hajo
 * 
 *   ** NOTHING TO DO *******
 *
 */
public final class User implements Serializable {

    private static final long serialVersionUID = Constants.SERIAL_V_ID;

    private final String name;

    public User(String name) {
        this.name = name;
     
    }

    public String getName() {
        return name;
    }

    @Override
    public String toString() {
        return "User[" + name + "]"; 
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        User other = (User) obj;
        if (name == null) {
            if (other.name != null)
                return false;
        } else if (!name.equals(other.name))
            return false;
        return true;
    }
 
}
