package src_out;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import edu.gu.hajo.dict.trie.ITrie;
import edu.gu.hajo.dict.trie.TrieNode;

/**
 * Sketch for the getMatches method
 * 
 */
public class Dictionary  {

    // The words in the "from" language
    private ITrie source;
    // Translations of the words in source (the "to" language)
    private ITrie target;

    public Dictionary(List<DictionaryEntry> data) {
        
    }

    public Dictionary(ITrie source, ITrie target, List<DictionaryEntry> data) {
        this.source = source;
        this.target = target;
      // More 
    }

    /**
     * This is a bit complicated because we will only get nodes
     * for the leafs in the Trie (ending of long words). 
     * Have to check if other (parent) nodes have a peer (neighbor) i.e.
     * if the long word has a short one inside.
     * @param prefix
     * @return
     */
    public List<DictionaryEntry> getMatches(String prefix) {
        // This is what we finally will return
        List<DictionaryEntry> entries = new ArrayList<DictionaryEntry>();

        // Need this for no duplicates (else biff, bilnär, bifurkation will create three "bi" in list)
        Set<String> strs = new HashSet<String>(); 
        
        // Nodes for words that is part of a longer word ("bar" is part of "barbar")
        Set<TrieNode> shortWords = new HashSet<TrieNode>();
        
        // Get a list of nodes (only leaf nodes in tree, i.e. ending of a long word like "barbar")
        List<TrieNode> nodes = source.getNodes(prefix);
        
        // Check all long words if a short one is inside
        for (TrieNode n : nodes) {
            System.out.println("*" + source.getWord(n));
            TrieNode pos = n.getParent();
            // Go up from next last node in word
            while (pos.getParent() != null) {
                if (pos.hasPeers()) {
                    String s = source.getWord(pos);
                    // No duplicates
                    if (!strs.contains(s)) {
                        System.out.println(source.getWord(pos));
                        // Add to duplicate list
                        strs.add(s);
                        shortWords.add(pos);
                    }
                }
                pos = pos.getParent();
            }
        }
        // All nodes that have a translation (neighbor or peer as I call them
        nodes.addAll(shortWords);

        // Now, for all nodes in list
        // if it has a peer (neighbor)
        // Get the word (string) then get all neighbors (collect them in a string list)
        // Create an entry out of the word end the string-list
        // add to entries
        
        return entries;
    }
}
