package timertask;

import java.util.Timer;
import java.util.TimerTask;

/**
 * Using a timer and a timertask (will create and run in own thread)
 * @author hajo 
 *
 */
public class UseTimerTask {
  
  // Anonymous subclass of TimerTask
  private static TimerTask task = new TimerTask() {

    // This will run every 3rd sec.
    @Override
    public void run() {
      System.out.println(Thread.currentThread());
      System.out.println("Over and over again...");

    }
  };

  

  public static void main(String[] args) {
    // Create a timer. NOTE java.util.Timer
    Timer t = new Timer("MyTimer");
    // Schedule task for 2 sec delay and 3 sec period
    t.schedule(task, 2000, 3000);
  }
}
