package swing.mvc;

import java.awt.BorderLayout;

import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.ListModel;

/**
 *  Swing is MVC. Using the components model
 *  Model is the data, the UI delegate will render
 * 
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class DefaultModel extends JFrame {

    public static void main(String[] args) {
        DefaultModel u = new DefaultModel();
        // Should use SwingUtilities
        u.setSize(200, 200);
        u.setVisible(true);
      
    }
    
    private JList<String> list;
    
    public DefaultModel(){
        // Will create read only list
        // list = new JList<String>(new String[]{"a", "b", "c"});
        
        // Must create new model and put into list for every change
        DefaultListModel<String> listModel = new DefaultListModel<String>();
        listModel.addElement("Jane Doe");
        listModel.addElement("John Smith");
        listModel.addElement("Kathy Green");
        
        list = new JList<>();
        // Replace old model. Note this will fire an event, use F3
        list.setModel(listModel); 
        
        // Get read only interface
        ListModel<String> lm = list.getModel();
        
        
        this.getContentPane().add(list, BorderLayout.NORTH); 
    }
}
