package threads.deadlock;

/**
 * Deadlock by lock order
 * Run many times to see different outcome
 *
 */
public class DeadlockByLockOrder { 

	public static Object cacheLock = new Object();
	public static Object tableLock = new Object();

	public void m1() {
		synchronized (cacheLock) {
			System.out.println(Thread.currentThread().getName() + " got lock for cachelock");
			synchronized (tableLock) {
				doSomething();
			}
		}
	}

	public void m2() {
		synchronized (tableLock) {
			System.out.println(Thread.currentThread().getName() + " got lock for tablelock");
			synchronized (cacheLock) {
				doSomethingElse();
			}
		}
	}

	private void doSomethingElse() {
		System.out.println("doSomethingElse");
	}

	private void doSomething() {
		System.out.println("doSomething");
	}

	public static void main(String[] args) {
		final DeadlockByLockOrder l = new DeadlockByLockOrder();
		Thread t1 = new Thread(new Runnable() {
			public void run() {
				while (true) {
					l.m1();
				}
			}
		});
		Thread t2 = new Thread(new Runnable() {
			public void run() {
				while (true) {
					l.m2();
				}
			}
		});
		t1.start();
		t2.start();
		try {
			t1.join();
			t2.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}
