package immutable;

/**
 * Using caching with immutable (so we don't create many
 * objects for the same value)
 * @author hajo
 *
 */
public class UseCachingSharing {

	
	@SuppressWarnings("unused")
	public static void main(String[] args) {
		// Bad create new object for each value;
		Integer zero = new Integer(0);
		
		// Better, reuse cached object (caches at least -128 - 127 incl.)
		Integer four = Integer.valueOf(4);
		
		// Bad new object
		boolean b1 = new Boolean("true");
		
		// Better reuse cached object
		boolean b2 = Boolean.TRUE;
	}
}
