package initialization;

/**
 * Illustrating initialization order (if no inheritance used)
 * @author hajo
 *
 */
public class OrderOfInitialization {

	public static void main(String[] args) {
		new MyClass();
	}

	public static class MyClass {
		// Init instance var
		public A instanceVar = new A();
		// Init class var
		public static B classVar = new B();

		// Class initializer
		static {
			System.out.println("Doing static block");
		}
		// Instance initializer (useful if class has no name = no Constructor)
		{
			System.out.println("Doing instance block");
		}

		// Constructor
		public MyClass() {
			// Imagine instance initializer run here
			System.out.println("Alive : " + this.getClass().getSimpleName());
		}
	}

	// --------- TYPES --------------------------
	
	public static class A {
		public A(){
			System.out.println("Alive : " + this.getClass().getSimpleName());
		}
	}

	public static class B {
		public B(){
			System.out.println("Alive : " + this.getClass().getSimpleName());
		}
	}

}
