package innerclasses;

/**
 * Class with an inner class
 * The inner has a hidden reference to enclosing
 * instance (so must create instance of enclosing)
 * @author hajo
 *
 */
public class ClassWithInnerClass {

	private String data = "Outer";

	// --------- Inner class ----------------------
	/*private */ class InnerClass { 

		public String data = "Inner";


		public String getOuterData() {
			// No problem (has reference to outer instance)
			return ClassWithInnerClass.this.data; 
		}
		
		public String getInnerData() {
			return this.data; 
		}
		
	} // --------------------------------------

	public String getData() {
		return data;
	}
}
