package innerclasses;

/**
 * Class with an top level nested class (no real inner class
 * no hidden reference to enclosing instance)
 * Slightly more efficient (no reference) 
 * 
 * @author hajo
 *
 */
public class ClassWithInnerStaticClass {

	private String data = "Outer";
	private static String data2 = "StaticOuter";

	// --------- Nested top level class ----------------------
	/*private*/ static class InnerClass { 
		public String data = "Inner";

		/*
		public String getOuterData() {
			// Can't no reference to enclosing instance
			return ClassWithInnerStaticClass.this.data; 
		}*/
		
		public String getInnerData() {
			return this.data; 
		}	
		public String geStaticData() {
			return data2;
		}
	} // --------------------------------------

	public String getData() {
		return data;
	}
}
