package singleton;

/**
 * Other style of Singleton (possible to inherit)
 * @author hajo
 *
 */
public class ClassSingleton {
	/**
	  * Single instance created upon class loading.
	  */
	private static final ClassSingleton INSTANCE = new ClassSingleton();

	public static ClassSingleton getInstance() {
		return INSTANCE;
	}
	// Can't use new
	private ClassSingleton() {
	}
	
	public void doIt(){
		System.out.println("doIt");
	}
}
