package failureatomicity;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 * Change state after any statement possible causing an exception
 * @author hajo
 *
 */
public class FailureAtomicity {

    private boolean done = false;

    
    public void noFailureAtomicity() throws FileNotFoundException {
        done = true;  // State possible corrut ...
        Scanner sc = new Scanner(new File("afile")); // .. if exception here
        // read data....
        sc.close();
    }

    public void failureAtomicity() throws FileNotFoundException {
        Scanner sc = new Scanner(new File("afile"));
       
        sc.close();
        done = true; // Not executed if exception!
    }

}
