package initialization;

/**
 * Illustrating initialization order (if no inheritance used)
 *
 * @author hajo
 *
 */
public class MyClass {

    // Init instance var
    public A instanceVar = new A("instance");
    // Init class var
    public static A classVar = new A("static");

    // static (class) initializer
    static {
        System.out.println("Doing static block");
    }

    // Instance initializer (useful if class has no name i.e. no Constructor)
    {
        System.out.println("Doing instance block");
    }

    // Constructor
    public MyClass() {
        // Imagine instance initializer run here
        System.out.println("Alive : " + this.getClass().getSimpleName());
    }
}
