package innerclasses;

/**
 * Class with an inner class The inner has a hidden reference to enclosing
 * instance (so must create instance of enclosing)
 *
 * @author hajo
 *
 */
public class OuterClass {

    private String data = "Outer";
  

    // --------- Inner class ----------------------
	/*private */ class InnerClass {

        public String data = "Inner";
        // public static String = "InnerStatic";  // Not allowed

        public String getOuterData() {
            // No problem (has reference to outer instance)
            return OuterClass.this.data;
        }

        public String getInnerData() {
            return this.data;
        }

    } // --------------------------------------

    public String getData() {
        return data;
    }
    
    public String getInnerData() {
        return new InnerClass().data;
    }
}
