package nulls;

import java.util.ArrayList;
import java.util.List;

import nulls.option.None;
import nulls.option.Option;
import nulls.option.Some;

/**
 * Avoid returning nulls from methods
 * @author hajo
 *
 */
public class DontReturnNull {

	public static void main(String[] args) {
		MyClass m = new MyClass();
		String s = m.badFind("abc");

		// Forgot null check!!!
		// s.length();


	}
	
	// ----------- TYPES ------------

	public static class MyClass {
		List<String> strs = new ArrayList<>();

		// Bad! Passing the problems to caller
		public String badFind(String s) {
			int i = strs.indexOf(s);
			if (i >= 0) {
				return strs.get(i);
			} else {
				return null;
			}
		}

		// Better
		public List<String> betterFind(String s) {
			List<String> result = new ArrayList<>();
			int i = strs.indexOf(s);
			if (i >= 0) {
				result.add(strs.get(i));
			}
			return result; // Return empty list
		}
	}

}
