package typeconversions;

import java.io.Serializable;

/**
 * Conversion between references
 * @author hajo
 *
 */
public class ReferenceConversions {

	// A widening reference conversion exists from any reference type S to 
	// any reference type T, provided S is a subtype (§4.10) of T.
	public void wideningReference() {
		Number n;
		Integer i = new Integer(1);

		// Number superclass of Integer (Integer extends Number), ok!
		n = i;
		System.out.println(n);
	}

	// Not type safe
	public void narrowingReference() {
		Object o = "abc"; // Object super class

		// No, compiler forbids (can use casting but's unsafe)
		// String s = o;

		System.out.println(o);
	}

	public void objectConversions() {
		Object o;
		Integer i = new Integer(1);
		o = i;
		o = "abc";
		System.out.println(o);
	}

	public void arrayConversion() {
		Integer[] iarr = new Integer[5];
		// No
		//Double [] dar2 = iarr2;

		// There's a widening conversion from Integer to Number
		Number[] darr = iarr;

		// Conversion to String
		System.out.println("" + iarr + darr);

		// Only class types compatible with arrays (also primitives)
		Object o = iarr;
		// Only interface types compatible with arrays
		Serializable s = iarr;
		Cloneable c = iarr;

		System.out.println(o);
	}
	
	public void stringConversion(){
        Integer i= new Integer(1);
        // No!
        // String s = i;
        
        // + is the only allowed context for string conversion
        // (one of operands must be String)
        System.out.println( "" + i );  //Ok 
    }
    
}
