package arrayloophole;

/**
 * The array loop hole (a hole in the type system)
 *
 * @author hajo
 */
public class TheArrayLoopHole {

    /*
     * If assuming [] is the array create operator
     * (makeArray) then it is a covariant operator 
     * 
     * public Object[] makeArray( Object o )
     * 
     * By covariance possible to get a sub type from above method
     * 
     */
    public static void main(String args[]) {
        String[] strings = new String[1];
        // Object[] :> String[] because Object :> String, so Ok!
        Object[] objects = strings;
        // Object :> Integer, no compilation complaints
        objects[0] = new Integer(1); // ...will throw ArrayStoreException runtime

        // Somewhere later we'll have a problem...(no compilaton error)
        String s = strings[0].substring(0);  // The array loophole!!
        System.out.println(s);
    }
}
