package enums;

/**
 * Using nested enum to simplify for users of class
 *
 * @author hajo
 */
public class Order {

    private OrderStatus status;

    // Nested Enum (implicit static, more later)
    public enum OrderStatus {

        // The names of the instances
        ACCEPTED, REJECTED, PAID, SHIPPED;
    }

    public void setStatus(OrderStatus status) {
        this.status = status;
    }

    public OrderStatus getStatus() {
        return status;
    }

    public boolean shipOrder(Order order) {
        if (order.getStatus() == OrderStatus.ACCEPTED) {
            shipIt();
            return true;
        } else {
            return false;
        }
    }

    private void shipIt() {
        // Do it
    }
}
