package enums;

/**
 * Enum's should be used when a small number of constant values needed
 *
 * @author hajo
 *
 */
public class TestEnum {

    public static void main(String[] args) {
        testWeekday();
        testOrderStatus();
    }

    private static void testWeekday() {
        Weekday d = Weekday.FRIDAY;

        // Enum to String (toString automatically called)
        System.out.println(d);
        // All values (method autmatically created)
        for (Weekday wd : Weekday.values()) {
            System.out.println(wd);
        }
        // Implicit numbered
        System.out.println(d.ordinal());

        // From String to enum
        Weekday friday = Weekday.valueOf("FRIDAY");

        if (friday == Weekday.FRIDAY) {
            System.out.println("Safe to use == for comparision");
        }
        
        System.out.println("Hours to work " + Weekday.TUESDAY.getHoursToWork());
        System.out.println("Hours to work " + Weekday.FRIDAY.getHoursToWork());
    }

    private static void testOrderStatus() {
        // All possible choices defined in Order (using an enum) GOOD!
        Order o = new Order();
        o.setStatus(Order.OrderStatus.ACCEPTED);
    }

}
