package enums;

/**
 * Enum for weekdays
 * @author hajo
 */
// Must not be abstract
public enum Weekday /* implements possible but not extends */ {

    // MUST have these first (implicit static and final)
    // The names of the instances (order matters)
    MONDAY, TUESDAY(4), WEDNESDAY, THUSDAY(4), FRIDAY;

    private int hoursToWork = 8; // Instance vars possible

    // Privet constructor only
    private Weekday() {  
    }

    // Can have more ctors
    private Weekday(int hoursToWork) {
        this.hoursToWork = hoursToWork;
    }

    public int getHoursToWork(){
        return hoursToWork;
    }
    
    // Not tested
    public Weekday after(Weekday d) {
        int i = (d.ordinal() + 1) % Weekday.values().length;
        Weekday[] days = Weekday.values();
        return days[i];
    }
}
