package override;

/**
 * This show overload by mistake
 *
 * @author hajo
 *
 */
public class OverrideMisstake {

    public void test() {
        B b = new B();
        System.out.println("Twice as much is " + b.doubleIt(5.0));
        System.out.println("Twice as much is " + b.doubleIt(5));
    }

    // ---------- Types ------------------
    public class A {

        // Possible to override
        public double doubleIt(double d) {
            return 10 * d;
        }
    }

    public class B extends A {

        // OOPS! Changes the method signature, no override
        //Should have used @Override!
        public double doubleIt(int i) {
            return 2 * i;
        }
        // Got an overload;

        // No same signature in same scope
        /*public int doubleIt(int i) {
         return 2 * i;
         }*/
    }

    public class C extends A {

        // No override, different returntype
        public int doubleIt(int i) {
            return 5 * i;
        }
    }

}
