package rtti;

/**
 * Demonstration of runtime type information I.e. there is type information to
 * use during runtime (by the system)
 *
 * This is special, avoid explicit use if possible
 *
 * @author hajo
 *
 */
public class GetClass {

    public void test() {
        IA ia = new A(); // Type compatible
        A a1 = new A();
        A a2 = new B();
        
        Class<IA> clazz1 = IA.class;
        Class<A> clazz2 = A.class;
        Class<B> clazz3 = B.class;
        
        // Will show GetClass$IA because IA is an inner interface 
        System.out.println(clazz1);
        System.out.println(clazz2);
        System.out.println(clazz3);
        // No
        //Class<A> clazz4 = B.class;
       
         // ? Unknown class, more later... 
         Class<? extends IA> clazz4 = a1.getClass();
         Class<? extends IA> clazz5 = a2.getClass();
        
         // Will show the runtime type
         System.out.println("Runtime type" + clazz4);
         System.out.println("Runtime type" + clazz5);
    }

    // ------------------ TYPES ---------------------------
    public interface IA {

      
    }

    public class A implements IA {

       
    }

    public class B extends A implements IA {

      
    }

}
