package rtti;

/**
 *
 * At run time, the result of the instanceof operator is true if the value of
 * the RelationalExpression is not null and the reference could be cast (JLS
 * 15.16) to the ReferenceType without raising a ClassCastException. Otherwise
 * the result is false.
 *
 * @author hajo
 *
 */
public class InstanceOfs {

    public void test() {
        IMyInterface mi1 = new A(); // Type compatible
        IMyInterface mi2 = new B(); // Type compatible

        // Is mi1 type compatible with A (or sub type)
        if (mi1 instanceof A) {
            System.out.println("Yes it's A");
            A a = (A) mi1; // Safe
        }
        if (!(mi1 instanceof B)) {
            System.out.println("No, it's not B");
        }
        if (mi1 instanceof IMyInterface) {
            System.out.println("Yes it's IMyInterface");
        }

        // Always false
        System.out.println(null instanceof Object);

        // Order matters, object first!
        // System.out.println(IMyInterface instanceof mi1);
    }

    // ------------------ TYPES ---------------------------
    public interface IMyInterface {

    }

    public class A implements IMyInterface {

    }

    public class B implements IMyInterface {

    }

}
